ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.27 by greg, Thu Oct 27 16:35:54 2011 UTC vs.
Revision 2.66 by greg, Fri Sep 16 17:54:56 2016 UTC

# Line 6 | Line 6
6   #       G. Ward
7   #
8   use strict;
9 + my $windoz = ($^O eq "MSWin32" or $^O eq "MSWin64");
10   use File::Temp qw/ :mktemp  /;
11   sub userror {
12 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
12 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-W][-t{3|4} Nlog2][-r \"ropts\"][-s \"x=string;y=string\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}C][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
13          exit 1;
14   }
15 < my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
16 < chomp $td;
15 > my ($td,$radscn,$mgfscn,$octree,$fsender,$bsender,$receivers,$facedat,$behinddat,$rmtmp);
16 > my ($tf,$rf,$tb,$rb,$tfx,$rfx,$tbx,$rbx,$tfz,$rfz,$tbz,$rbz,$cph,$sav);
17 > my ($curphase, $recovery);
18 > if ($#ARGV == 1 && "$ARGV[0]" =~ /^-rec/) {
19 >        $td = $ARGV[1];
20 >        open(MYAVH, "< $td/savedARGV.txt") or die "$td: invalid path\n";
21 >        @ARGV = <MYAVH>;
22 >        close MYAVH;
23 >        chomp @ARGV;
24 >        if (open(MYPH, "< $td/phase.txt")) {
25 >                while (<MYPH>) {
26 >                        chomp($recovery = $_);
27 >                }
28 >                close MYPH;
29 >        }
30 > } elsif ($windoz) {
31 >        my $tmploc = `echo \%TMP\%`;
32 >        chomp $tmploc;
33 >        $td = mkdtemp("$tmploc\\genBSDF.XXXXXX");
34 > } else {
35 >        $td = mkdtemp("/tmp/genBSDF.XXXXXX");
36 >        chomp $td;
37 > }
38 > if ($windoz) {
39 >        $radscn = "$td\\device.rad";
40 >        $mgfscn = "$td\\device.mgf";
41 >        $octree = "$td\\device.oct";
42 >        $fsender = "$td\\fsender.rad";
43 >        $bsender = "$td\\bsender.rad";
44 >        $receivers = "$td\\receivers.rad";
45 >        $facedat = "$td\\face.dat";
46 >        $behinddat = "$td\\behind.dat";
47 >        $tf = "$td\\tf.dat";
48 >        $rf = "$td\\rf.dat";
49 >        $tb = "$td\\tb.dat";
50 >        $rb = "$td\\rb.dat";
51 >        $tfx = "$td\\tfx.dat";
52 >        $rfx = "$td\\rfx.dat";
53 >        $tbx = "$td\\tbx.dat";
54 >        $rbx = "$td\\rbx.dat";
55 >        $tfz = "$td\\tfz.dat";
56 >        $rfz = "$td\\rfz.dat";
57 >        $tbz = "$td\\tbz.dat";
58 >        $rbz = "$td\\rbz.dat";
59 >        $cph = "$td\\phase.txt";
60 >        $rmtmp = "rd /S /Q $td";
61 > } else {
62 >        $radscn = "$td/device.rad";
63 >        $mgfscn = "$td/device.mgf";
64 >        $octree = "$td/device.oct";
65 >        $fsender = "$td/fsender.rad";
66 >        $bsender = "$td/bsender.rad";
67 >        $receivers = "$td/receivers.rad";
68 >        $facedat = "$td/face.dat";
69 >        $behinddat = "$td/behind.dat";
70 >        $tf = "$td/tf.dat";
71 >        $rf = "$td/rf.dat";
72 >        $tb = "$td/tb.dat";
73 >        $rb = "$td/rb.dat";
74 >        $tfx = "$td/tfx.dat";
75 >        $rfx = "$td/rfx.dat";
76 >        $tbx = "$td/tbx.dat";
77 >        $rbx = "$td/rbx.dat";
78 >        $tfz = "$td/tfz.dat";
79 >        $rfz = "$td/rfz.dat";
80 >        $tbz = "$td/tbz.dat";
81 >        $rbz = "$td/rbz.dat";
82 >        $cph = "$td/phase.txt";
83 >        $rmtmp = "rm -rf $td";
84 > }
85   my @savedARGV = @ARGV;
86 + my $rfluxmtx = "rfluxmtx -ab 5 -ad 700 -lw 3e-6";
87 + my $wrapper = "wrapBSDF";
88   my $tensortree = 0;
89   my $ttlog2 = 4;
90   my $nsamp = 2000;
20 my $rtargs = "-w -ab 5 -ad 700 -lw 3e-6";
91   my $mgfin = 0;
92   my $geout = 1;
93   my $nproc = 1;
94 + my $docolor = 0;
95   my $doforw = 0;
96   my $doback = 1;
97 < my $pctcull = 95;
98 < my $gunit = "Meter";
97 > my $pctcull = 90;
98 > my $gunit = "meter";
99 > my $curspec = "Visible";
100   my @dim;
101   # Get options
102   while ($#ARGV >= 0) {
103          if ("$ARGV[0]" =~ /^[-+]m/) {
104                  $mgfin = ("$ARGV[0]" =~ /^\+/);
105          } elsif ("$ARGV[0]" eq "-r") {
106 <                $rtargs = "$rtargs $ARGV[1]";
106 >                $rfluxmtx .= " $ARGV[1]";
107                  shift @ARGV;
108          } elsif ("$ARGV[0]" =~ /^[-+]g/) {
109                  $geout = ("$ARGV[0]" =~ /^\+/);
# Line 40 | Line 112 | while ($#ARGV >= 0) {
112                          die "Illegal geometry unit '$gunit': must be meter, foot, inch, centimeter, or millimeter\n";
113                  }
114                  shift @ARGV;
115 +        } elsif ("$ARGV[0]" =~ /^[-+]C/) {
116 +                $docolor = ("$ARGV[0]" =~ /^\+/);
117          } elsif ("$ARGV[0]" =~ /^[-+]f/) {
118                  $doforw = ("$ARGV[0]" =~ /^\+/);
119          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
120                  $doback = ("$ARGV[0]" =~ /^\+/);
121          } elsif ("$ARGV[0]" eq "-t") {
122 +                # Use value < 0 for rttree_reduce bypass
123                  $pctcull = $ARGV[1];
124 +                if ($pctcull >= 100) {
125 +                        die "Illegal -t culling percentage, must be < 100\n";
126 +                }
127                  shift @ARGV;
128          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
129                  $tensortree = substr($ARGV[0], 2, 1);
130                  $ttlog2 = $ARGV[1];
131                  shift @ARGV;
132 +        } elsif ("$ARGV[0]" eq "-s") {
133 +                $wrapper .= " -f \"$ARGV[1]\"";
134 +                shift @ARGV;
135 +        } elsif ("$ARGV[0]" eq "-W") {
136 +                $wrapper .= " -W";
137          } elsif ("$ARGV[0]" eq "-c") {
138                  $nsamp = $ARGV[1];
139                  shift @ARGV;
# Line 70 | Line 153 | while ($#ARGV >= 0) {
153   }
154   # Check that we're actually being asked to do something
155   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
156 < # Name our own persist file?
157 < my $persistfile;
158 < if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
159 <        $persistfile = "$td/pfile.txt";
160 <        $rtargs = "-PP $persistfile $rtargs";
156 > $wrapper .= $tensortree ? " -a t$tensortree" : " -a kf -c";
157 > $wrapper .= " -u $gunit";
158 > if (!defined $recovery) {
159 >        # Issue warning for unhandled reciprocity case
160 >        print STDERR "Warning: recommend both +forward and +backward with -t3\n" if
161 >                        ($tensortree==3 && !($doforw && $doback));
162 >        # Get scene description and dimensions
163 >        if ( $mgfin ) {
164 >                system "mgf2rad @ARGV > $radscn";
165 >                die "Could not load MGF input\n" if ( $? );
166 >        } else {
167 >                system "xform -e @ARGV > $radscn";
168 >                die "Could not load Radiance input\n" if ( $? );
169 >        }
170   }
79 # Get scene description and dimensions
80 my $radscn = "$td/device.rad";
81 my $mgfscn = "$td/device.mgf";
82 my $octree = "$td/device.oct";
83 if ( $mgfin ) {
84        system "mgfilt '#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus' @ARGV > $mgfscn";
85        die "Could not load MGF input\n" if ( $? );
86        system "mgf2rad $mgfscn > $radscn";
87 } else {
88        system "xform -e @ARGV > $radscn";
89        die "Could not load Radiance input\n" if ( $? );
90        system "rad2mgf $radscn > $mgfscn" if ( $geout );
91 }
171   if ($#dim != 5) {
172          @dim = split ' ', `getbbox -h $radscn`;
173   }
174 < print STDERR "Warning: Device extends into room\n" if ($dim[5] > 1e-5);
175 < # Add receiver surfaces (rectangular)
176 < my $fmodnm="receiver_face";
177 < my $bmodnm="receiver_behind";
178 < open(RADSCN, ">> $radscn");
100 < print RADSCN "void glow $fmodnm\n0\n0\n4 1 1 1 0\n\n";
101 < print RADSCN "$fmodnm source f_receiver\n0\n0\n4 0 0 1 180\n";
102 < print RADSCN "void glow $bmodnm\n0\n0\n4 1 1 1 0\n\n";
103 < print RADSCN "$bmodnm source b_receiver\n0\n0\n4 0 0 -1 180\n";
104 < close RADSCN;
105 < # Generate octree
106 < system "oconv -w $radscn > $octree";
107 < die "Could not compile scene\n" if ( $? );
108 < # Output XML prologue
109 < print
110 < '<?xml version="1.0" encoding="UTF-8"?>
111 < <WindowElement xmlns="http://windows.lbl.gov" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://windows.lbl.gov/BSDF-v1.4.xsd">
112 < ';
113 < print "<!-- File produced by: genBSDF @savedARGV -->\n";
114 < print
115 < '<WindowElementType>System</WindowElementType>
116 < <Optical>
117 < <Layer>
118 <        <Material>
119 <                <Name>Name</Name>
120 <                <Manufacturer>Manufacturer</Manufacturer>
121 < ';
122 < printf "\t\t<Thickness unit=\"$gunit\">%.3f</Thickness>\n", $dim[5] - $dim[4];
123 < printf "\t\t<Width unit=\"$gunit\">%.3f</Width>\n", $dim[1] - $dim[0];
124 < printf "\t\t<Height unit=\"$gunit\">%.3f</Height>\n", $dim[3] - $dim[2];
125 < print "\t\t<DeviceType>Integral</DeviceType>\n";
126 < # Output MGF description if requested
127 < if ( $geout ) {
128 <        print "\t\t<Geometry format=\"MGF\" unit=\"$gunit\">\n";
129 <        printf "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
130 <        open(MGFSCN, "< $mgfscn");
131 <        while (<MGFSCN>) { print $_; }
132 <        close MGFSCN;
133 <        print "xf\n";
134 <        print "\t\t</Geometry>\n";
174 > die "Device entirely inside room!\n" if ($dim[4] >= 0);
175 > if ($dim[5] > 1e-5) {
176 >        print STDERR "Warning: Device extends into room\n";
177 > } elsif ($dim[5]*$dim[5] > .01*($dim[1]-$dim[0])*($dim[3]-$dim[2])) {
178 >        print STDERR "Warning: Device far behind Z==0 plane\n";
179   }
180 < print " </Material>\n";
181 < # Set up surface sampling
182 < my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + .5);
183 < my $ny = int($nsamp/$nx + .5);
184 < $nsamp = $nx * $ny;
180 > # Assume Zmax==0 to derive thickness so pkgBSDF will work
181 > $wrapper .= ' -f "t=' . (-$dim[4]) . ';w=' . ($dim[1] - $dim[0]) .
182 >                ';h=' . ($dim[3] - $dim[2]) . '"';
183 > # Calculate CIE (u',v') from Radiance RGB:
184 > my $CIEuv =     'Xi=.5141*Ri+.3239*Gi+.1620*Bi;' .
185 >                'Yi=.2651*Ri+.6701*Gi+.0648*Bi;' .
186 >                'Zi=.0241*Ri+.1229*Gi+.8530*Bi;' .
187 >                'den=Xi+15*Yi+3*Zi;' .
188 >                'uprime=4*Xi/den;vprime=9*Yi/den;' ;
189 > my $FEPS = 1e-5;
190   my $ns = 2**$ttlog2;
191 < my (@pdiv, $disk2sq, $sq2disk, $tcal, $kcal);
191 > my $nx = int(sqrt($nsamp*($dim[1]-$dim[0])/($dim[3]-$dim[2])) + 1);
192 > my $ny = int($nsamp/$nx + 1);
193 > $nsamp = $nx * $ny;
194 > $rfluxmtx .= " -n $nproc -c $nsamp";
195 > if (!defined $recovery) {
196 >        open(MYAVH, "> $td/savedARGV.txt");
197 >        foreach (@savedARGV) {
198 >                print MYAVH "$_\n";
199 >        }
200 >        close MYAVH;
201 >        # Generate octree
202 >        system "oconv -w $radscn > $octree";
203 >        die "Could not compile scene\n" if ( $? );
204 >        # Add MGF description if requested
205 >        if ( $geout ) {
206 >                open(MGFSCN, "> $mgfscn");
207 >                printf MGFSCN "xf -t %.6f %.6f 0\n", -($dim[0]+$dim[1])/2, -($dim[2]+$dim[3])/2;
208 >                close MGFSCN;
209 >                if ( $mgfin ) {
210 >                        system qq{mgfilt "#,o,xf,c,cxy,cspec,cmix,m,sides,rd,td,rs,ts,ir,v,p,n,f,fh,sph,cyl,cone,prism,ring,torus" @ARGV >> $mgfscn};
211 >                } else {
212 >                        system "rad2mgf $radscn >> $mgfscn";
213 >                }
214 >                open(MGFSCN, ">> $mgfscn");
215 >                print MGFSCN "xf\n";
216 >                close MGFSCN;
217 >                $wrapper .= " -g $mgfscn";
218 >        }
219 >        # Create receiver & sender surfaces (rectangular)
220 >        open(RADSCN, "> $receivers");
221 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=-sc$ns\n" : "h=-kf\n");
222 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$facedat\n\n";
223 >        print RADSCN "void glow receiver_face\n0\n0\n4 1 1 1 0\n\n";
224 >        print RADSCN "receiver_face source f_receiver\n0\n0\n4 0 0 1 180\n\n";
225 >        print RADSCN '#@rfluxmtx ' . ($tensortree ? "h=+sc$ns\n" : "h=+kf\n");
226 >        print RADSCN '#@rfluxmtx ' . "u=-Y o=$behinddat\n\n";
227 >        print RADSCN "void glow receiver_behind\n0\n0\n4 1 1 1 0\n\n";
228 >        print RADSCN "receiver_behind source b_receiver\n0\n0\n4 0 0 -1 180\n";
229 >        close RADSCN;
230 >        # Prepare sender surfaces
231 >        if ( $tensortree != 3 ) {       # Isotropic tensor tree is exception
232 >                open (RADSCN, "> $fsender");
233 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=-sc$ns\n\n" : "h=-kf\n\n");
234 >                print RADSCN "void polygon fwd_sender\n0\n0\n12\n";
235 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[4]-$FEPS;
236 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[4]-$FEPS;
237 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[4]-$FEPS;
238 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[4]-$FEPS;
239 >                close RADSCN;
240 >                open (RADSCN, "> $bsender");
241 >                print RADSCN '#@rfluxmtx u=-Y ' . ($tensortree ? "h=+sc$ns\n\n" : "h=+kf\n\n");
242 >                print RADSCN "void polygon bwd_sender\n0\n0\n12\n";
243 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[2], $dim[5]+$FEPS;
244 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[2], $dim[5]+$FEPS;
245 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[1], $dim[3], $dim[5]+$FEPS;
246 >                printf RADSCN "\t%e\t%e\t%e\n", $dim[0], $dim[3], $dim[5]+$FEPS;
247 >                close RADSCN;
248 >        }
249 >        print STDERR "Recover using: $0 -recover $td\n";
250 > }
251 > open(MYPH, ">> $td/phase.txt");
252 > {               # unbuffer output to MYPH
253 >        my $ofh = select MYPH;
254 >        $| = 1;
255 >        select $ofh;
256 > }
257 > $curphase = 0;
258 > # Function to determine if next phase should be skipped or recovered
259 > sub do_phase {
260 >        $curphase++;
261 >        if (defined $recovery) {
262 >                if ($recovery == $curphase) { return -1; }
263 >                if ($recovery > $curphase) { return 0; }
264 >        }
265 >        print MYPH "$curphase\n";
266 >        return 1;
267 > }
268   # Create data segments (all the work happens here)
269   if ( $tensortree ) {
270          do_tree_bsdf();
271   } else {
272          do_matrix_bsdf();
273   }
274 < # Output XML epilogue
275 < print
276 < '</Layer>
277 < </Optical>
153 < </WindowElement>
154 < ';
274 > # Output XML
275 > print STDERR "Running: $wrapper\n";
276 > system "$wrapper -C \"Created by: genBSDF @savedARGV\"";
277 > die "Could not wrap BSDF data\n" if ( $? );
278   # Clean up temporary files and exit
279 < exec("rm -rf $td");
279 > exec $rmtmp;
280  
281   #-------------- End of main program segment --------------#
282  
160 #++++++++++++++ Kill persistent rtrace +++++++++++++++++++#
161 sub persist_end {
162        if ( $persistfile && open(PFI, "< $persistfile") ) {
163                while (<PFI>) {
164                        s/^[^ ]* //;
165                        kill('ALRM', $_);
166                        last;
167                }
168                close PFI;
169        }
170 }
171
283   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
284   sub do_tree_bsdf {
285 < # Get sampling rate and subdivide task
286 < my $ns2 = $ns;
287 < $ns2 /= 2 if ( $tensortree == 3 );
288 < my $nsplice = $nproc;
289 < $nsplice *= 10 if ($nproc > 1);
179 < $nsplice = $ns2 if ($nsplice > $ns2);
180 < $nsplice = 999 if ($nsplice > 999);
181 < @pdiv = (0, int($ns2/$nsplice));
182 < my $nrem = $ns2 % $nsplice;
183 < for (my $i = 1; $i < $nsplice; $i++) {
184 <        my $nv = $pdiv[$i] + $pdiv[1];
185 <        ++$nv if ( $nrem-- > 0 );
186 <        push @pdiv, $nv;
187 < }
188 < die "Script error 1" if ($pdiv[-1] != $ns2);
189 < # Shirley-Chiu mapping from unit square to disk
190 < $sq2disk = '
191 < in_square_a = 2*in_square_x - 1;
192 < in_square_b = 2*in_square_y - 1;
193 < in_square_rgn = if(in_square_a + in_square_b,
194 <                        if(in_square_a - in_square_b, 1, 2),
195 <                        if(in_square_b - in_square_a, 3, 4));
196 < out_disk_r = .999995*select(in_square_rgn, in_square_a, in_square_b,
197 <                        -in_square_a, -in_square_b);
198 < out_disk_phi = PI/4 * select(in_square_rgn,
199 <                                in_square_b/in_square_a,
200 <                                2 - in_square_a/in_square_b,
201 <                                4 + in_square_b/in_square_a,
202 <                                if(in_square_b*in_square_b,
203 <                                        6 - in_square_a/in_square_b, 0));
204 < Dx = out_disk_r*cos(out_disk_phi);
205 < Dy = out_disk_r*sin(out_disk_phi);
206 < Dz = sqrt(1 - out_disk_r*out_disk_r);
207 < ';
208 < # Shirley-Chiu mapping from unit disk to square
209 < $disk2sq = '
210 < norm_radians(p) : if(-p - PI/4, p + 2*PI, p);
211 < in_disk_r = .999995*sqrt(Dx*Dx + Dy*Dy);
212 < in_disk_phi = norm_radians(atan2(Dy, Dx));
213 < in_disk_rgn = floor((in_disk_phi + PI/4)/(PI/2)) + 1;
214 < out_square_a = select(in_disk_rgn,
215 <                        in_disk_r,
216 <                        (PI/2 - in_disk_phi)*in_disk_r/(PI/4),
217 <                        -in_disk_r,
218 <                        (in_disk_phi - 3*PI/2)*in_disk_r/(PI/4));
219 < out_square_b = select(in_disk_rgn,
220 <                        in_disk_phi*in_disk_r/(PI/4),
221 <                        in_disk_r,
222 <                        (PI - in_disk_phi)*in_disk_r/(PI/4),
223 <                        -in_disk_r);
224 < out_square_x = (out_square_a + 1)/2;
225 < out_square_y = (out_square_b + 1)/2;
226 < ';
227 < # Announce ourselves in XML output
228 < print "\t<DataDefinition>\n";
229 < print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
230 < print "\t</DataDefinition>\n";
231 < # Fork parallel rtcontrib processes to compute each side
232 < my $npleft = $nproc;
233 < if ( $doback ) {
234 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
235 <                if (! $npleft ) {
236 <                        wait();
237 <                        die "rtcontrib process reported error" if ( $? );
238 <                        $npleft++;
239 <                }
240 <                bg_tree_rtcontrib(0, $splice);
241 <                $npleft--;
242 <        }
243 <        while (wait() >= 0) {
244 <                die "rtcontrib process reported error" if ( $? );
245 <                $npleft++;
246 <        }
247 <        persist_end();
248 <        ttree_out(0);
249 < }
250 < if ( $doforw ) {
251 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
252 <                if (! $npleft ) {
253 <                        wait();
254 <                        die "rtcontrib process reported error" if ( $? );
255 <                        $npleft++;
256 <                }
257 <                bg_tree_rtcontrib(1, $splice);
258 <                $npleft--;
259 <        }
260 <        while (wait() >= 0) {
261 <                die "rtcontrib process reported error" if ( $? );
262 <                $npleft++;
263 <        }
264 <        persist_end();
265 <        ttree_out(1);
266 < }
285 >
286 >        # Run rfluxmtx processes to compute each side
287 >        do_ttree_dir(0) if ( $doback );
288 >        do_ttree_dir(1) if ( $doforw );
289 >
290   }       # end of sub do_tree_bsdf()
291  
292 < # Run rtcontrib process in background to generate tensor tree samples
293 < sub bg_tree_rtcontrib {
271 <        my $pid = fork();
272 <        die "Cannot fork new process" unless defined $pid;
273 <        if ($pid > 0) { return $pid; }
292 > # Call rfluxmtx and process tensor tree BSDF for the given direction
293 > sub do_ttree_dir {
294          my $forw = shift;
295 <        my $pn = shift;
296 <        my $pbeg = $pdiv[$pn];
297 <        my $plen = $pdiv[$pn+1] - $pbeg;
298 <        my $matargs = "-m $bmodnm";
279 <        if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
280 <        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
281 <                "-e '$disk2sq' -bn '$ns*$ns' " .
282 <                "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
283 <                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
295 >        my $r = do_phase();
296 >        if (!$r) { return; }
297 >        $r = ($r < 0) ? " -r" : "";
298 >        my $cmd;
299          if ( $tensortree == 3 ) {
300                  # Isotropic BSDF
301 <                $cmd = "cnt $plen $ny $nx " .
302 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
303 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
304 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
305 <                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
306 <                        "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
307 <                        "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
308 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
309 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
310 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
311 <                        "| $cmd";
301 >                my $ns2 = $ns / 2;
302 >                if ($windoz) {
303 >                        $cmd = "cnt $ns2 $ny $nx " .
304 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
305 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
306 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
307 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
308 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
309 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
310 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
311 >                                qq{-e "\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz" } .
312 >                                qq{-e "\$4=Dx;\$5=Dy;\$6=myDz" } .
313 >                                "| $rfluxmtx$r -fa -y $ns2 - $receivers -i $octree";
314 >                } else {
315 >                        $cmd = "cnt $ns2 $ny $nx " .
316 >                                qq{| rcalc -e "r1=rand(.8681*recno-.673892)" } .
317 >                                qq{-e "r2=rand(-5.37138*recno+67.1737811)" } .
318 >                                qq{-e "r3=rand(+3.17603772*recno+83.766771)" } .
319 >                                qq{-e "Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)" } .
320 >                                qq{-e "xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]" } .
321 >                                qq{-e "yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]" } .
322 >                                qq{-e "zp=$dim[5-$forw]" -e "myDz=Dz*($forw*2-1)" } .
323 >                                qq{-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' } .
324 >                                qq{-e '\$4=Dx;\$5=Dy;\$6=myDz' -of } .
325 >                                "| $rfluxmtx$r -h -ff -y $ns2 - $receivers -i $octree";
326 >                }
327          } else {
328                  # Anisotropic BSDF
329 <                # Sample area vertically to improve load balance, since
330 <                # shading systems usually have bilateral symmetry (L-R)
331 <                $cmd = "cnt $plen $ns $ny $nx " .
332 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
333 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
334 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
305 <                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
306 <                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
307 <                        "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
308 <                        "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
309 <                        "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
310 <                        "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
311 <                        "-e '\$1=xp-Dx;\$2=yp-Dy;\$3=zp-myDz' " .
312 <                        "-e '\$4=Dx;\$5=Dy;\$6=myDz' -of " .
313 <                        "| $cmd";
329 >                my $sender = ($bsender,$fsender)[$forw];
330 >                if ($windoz) {
331 >                        $cmd = "$rfluxmtx$r -fa $sender $receivers -i $octree";
332 >                } else {
333 >                        $cmd = "$rfluxmtx$r -h -ff $sender $receivers -i $octree";
334 >                }
335          }
336 < # print STDERR "Starting: $cmd\n";
337 <        exec($cmd);             # no return; status report to parent via wait
338 <        die "Cannot exec: $cmd\n";
339 < }       # end of bg_tree_rtcontrib()
336 >        print STDERR "Starting: $cmd\n";
337 >        system $cmd;
338 >        die "Failure running rfluxmtx" if ( $? );
339 >        ttree_out($forw);
340 > }       # end of do_ttree_dir()
341  
342 < # Simplify and output tensor tree results
342 > # Simplify and store tensor tree results
343   sub ttree_out {
344          my $forw = shift;
345 <        my $side = ("Back","Front")[$forw];
346 < # Only output one transmitted distribution, preferring backwards
347 < if ( !$forw || !$doback ) {
348 < print
349 < '       <WavelengthData>
350 <                <LayerNumber>System</LayerNumber>
351 <                <Wavelength unit="Integral">Visible</Wavelength>
352 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
353 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
354 <                <WavelengthDataBlock>
355 <                        <WavelengthDataDirection>Transmission</WavelengthDataDirection>
356 <                        <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
357 <                        <ScatteringDataType>BTDF</ScatteringDataType>
358 <                        <ScatteringData>
359 < ';
360 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
361 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
362 <        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
363 <        "| rttree_reduce -h -ff -t $pctcull -r $tensortree -g $ttlog2";
364 < die "Failure running rttree_reduce" if ( $? );
365 < print
366 < '                       </ScatteringData>
367 <                </WavelengthDataBlock>
368 <        </WavelengthData>
347 < ';
348 < }
349 < # Output reflection
350 < print
351 < '       <WavelengthData>
352 <                <LayerNumber>System</LayerNumber>
353 <                <Wavelength unit="Integral">Visible</Wavelength>
354 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
355 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
356 <                <WavelengthDataBlock>
357 < ';
358 < print "\t\t\t<WavelengthDataDirection>Reflection $side</WavelengthDataDirection>\n";
359 < print
360 < '                       <AngleBasis>LBNL/Shirley-Chiu</AngleBasis>
361 <                        <ScatteringDataType>BRDF</ScatteringDataType>
362 <                        <ScatteringData>
363 < ';
364 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
365 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
366 <        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
367 <        "| rttree_reduce -h -ff -t $pctcull -r $tensortree -g $ttlog2";
368 < die "Failure running rttree_reduce" if ( $? );
369 < print
370 < '                       </ScatteringData>
371 <                </WavelengthDataBlock>
372 <        </WavelengthData>
373 < ';
345 >        my ($refldat,$transdat);
346 >        if ( $forw ) {
347 >                $transdat = $facedat;
348 >                $refldat = $behinddat;
349 >        } else {
350 >                $transdat = $behinddat;
351 >                $refldat = $facedat;
352 >        }
353 >        # Only output one transmitted anisotropic distribution, preferring backwards
354 >        if ( !$forw || !$doback || $tensortree==3 ) {
355 >                my $ttyp = ("tb","tf")[$forw];
356 >                ttree_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
357 >                if ( $docolor ) {
358 >                        ttree_comp($ttyp, "CIE-u", $transdat, ($tbx,$tfx)[$forw]);
359 >                        ttree_comp($ttyp, "CIE-v", $transdat, ($tbz,$tfz)[$forw]);
360 >                }
361 >        }
362 >        # Output reflection
363 >        my $rtyp = ("rb","rf")[$forw];
364 >        ttree_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
365 >        if ( $docolor ) {
366 >                ttree_comp($rtyp, "CIE-u", $refldat, ($rbx,$rfx)[$forw]);
367 >                ttree_comp($rtyp, "CIE-v", $refldat, ($rbz,$rfz)[$forw]);
368 >        }
369   }       # end of ttree_out()
370  
371 + # Call rttree_reduce on the given component
372 + sub ttree_comp {
373 +        my $typ = shift;
374 +        my $spec = shift;
375 +        my $src = shift;
376 +        my $dest = shift;
377 +        my $cmd;
378 +        if ($windoz) {
379 +                if ("$spec" eq "Visible") {
380 +                        $cmd = qq{rcalc -e "Omega:PI/($ns*$ns)" } .
381 +                                q{-e "Ri=$1;Gi=$2;Bi=$3" } .
382 +                                qq{-e "$CIEuv" } .
383 +                                q{-e "$1=Yi/Omega"};
384 +                } elsif ("$spec" eq "CIE-u") {
385 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
386 +                                qq{-e "$CIEuv" } .
387 +                                q{-e "$1=uprime"};
388 +                } elsif ("$spec" eq "CIE-v") {
389 +                        $cmd = q{rcalc -e "Ri=$1;Gi=$2;Bi=$3" } .
390 +                                qq{-e "$CIEuv" } .
391 +                                q{-e "$1=vprime"};
392 +                }
393 +        } else {
394 +                if ("$spec" eq "Visible") {
395 +                        $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
396 +                                q{-e 'Ri=$1;Gi=$2;Bi=$3' } .
397 +                                "-e '$CIEuv' " .
398 +                                q{-e '$1=Yi/Omega'};
399 +                } elsif ("$spec" eq "CIE-u") {
400 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
401 +                                "-e '$CIEuv' " .
402 +                                q{-e '$1=uprime'};
403 +                } elsif ("$spec" eq "CIE-v") {
404 +                        $cmd = q{rcalc -if3 -e 'Ri=$1;Gi=$2;Bi=$3' } .
405 +                                "-e '$CIEuv' " .
406 +                                q{-e '$1=vprime'};
407 +                }
408 +        }
409 +        if ($pctcull >= 0) {
410 +                my $avg = ( "$typ" =~ /^r[fb]/ ) ? " -a" : "";
411 +                my $pcull = ("$spec" eq "Visible") ? $pctcull :
412 +                                                     (100 - (100-$pctcull)*.25) ;
413 +                if ($windoz) {
414 +                        $cmd = "rcollate -ho -oc 1 $src | " .
415 +                                        $cmd .
416 +                                        " | rttree_reduce$avg -h -fa -t $pcull -r $tensortree -g $ttlog2";
417 +                } else {
418 +                        $cmd .= " -of $src " .
419 +                                        "| rttree_reduce$avg -h -ff -t $pcull -r $tensortree -g $ttlog2";
420 +                }
421 +                print STDERR "Running: $cmd\n";
422 +                system "$cmd > $dest";
423 +                die "Failure running rttree_reduce" if ( $? );
424 +        } else {
425 +                if ($windoz) {
426 +                        $cmd = "rcollate -ho -oc 1 $src | " . $cmd ;
427 +                } else {
428 +                        $cmd .= " $src";
429 +                }
430 +                open(DATOUT, "> $dest");
431 +                print DATOUT "{\n";
432 +                close DATOUT;
433 +                print STDERR "Running: $cmd\n";
434 +                system "$cmd >> $dest";
435 +                die "Failure running rcalc" if ( $? );
436 +                open(DATOUT, ">> $dest");
437 +                for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
438 +                        print DATOUT "0\n";
439 +                }
440 +                print DATOUT "}\n";
441 +                close DATOUT;
442 +        }
443 +        if ( "$spec" ne "$curspec" ) {
444 +                $wrapper .= " -s $spec";
445 +                $curspec = $spec;
446 +        }
447 +        $wrapper .= " -$typ $dest";
448 + }       # end of ttree_comp()
449 +
450   #------------- End of do_tree_bsdf() & subroutines -------------#
451  
452   #+++++++++++++++ Klems matrix BSDF generation +++++++++++++++#
453   sub do_matrix_bsdf {
454 < # Set up sampling of portal
455 < # Kbin to produce incident direction in full Klems basis with (x1,x2) randoms
456 < $tcal = '
457 < DEGREE : PI/180;
458 < sq(x) : x*x;
459 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
460 < Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
461 < Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
462 < Kmax : Kaccum(Knaz(0));
463 < Kfindrow(r, rem) : if(rem-Knaz(r)+.5, Kfindrow(r+1, rem-Knaz(r)), r);
464 < Krow = if(Kbin-(Kmax-.5), 0, Kfindrow(1, Kbin));
465 < Kcol = Kbin - Kaccum(Krow-1);
466 < Kazi = 360*DEGREE * (Kcol + (.5 - x2)) / Knaz(Krow);
467 < Kpol = DEGREE * (x1*Kpola(Krow) + (1-x1)*Kpola(Krow-1));
468 < sin_kpol = sin(Kpol);
469 < Dx = cos(Kazi)*sin_kpol;
470 < Dy = sin(Kazi)*sin_kpol;
471 < Dz = sqrt(1 - sin_kpol*sin_kpol);
472 < KprojOmega = PI * if(Kbin-.5,
473 <        (sq(cos(Kpola(Krow-1)*DEGREE)) - sq(cos(Kpola(Krow)*DEGREE)))/Knaz(Krow),
474 <        1 - sq(cos(Kpola(1)*DEGREE)));
475 < ';
476 < # Compute Klems bin from exiting ray direction (forward or backward)
477 < $kcal = '
478 < DEGREE : PI/180;
479 < abs(x) : if(x, x, -x);
480 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
481 < posangle(a) : if(-a, a + 2*PI, a);
482 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
483 < kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
484 < knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
411 < kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
412 < kfindrow(r, pol) : if(r-kpola(0)+.5, r,
413 <                if(pol-kpola(r), kfindrow(r+1, pol), r) );
414 < kazn(azi,inc) : if((360-.5*inc)-azi, floor((azi+.5*inc)/inc), 0);
415 < kbin2(pol,azi) = select(kfindrow(1, pol),
416 <                kazn(azi,360/knaz(1)),
417 <                kaccum(1) + kazn(azi,360/knaz(2)),
418 <                kaccum(2) + kazn(azi,360/knaz(3)),
419 <                kaccum(3) + kazn(azi,360/knaz(4)),
420 <                kaccum(4) + kazn(azi,360/knaz(5)),
421 <                kaccum(5) + kazn(azi,360/knaz(6)),
422 <                kaccum(6) + kazn(azi,360/knaz(7)),
423 <                kaccum(7) + kazn(azi,360/knaz(8)),
424 <                kaccum(8) + kazn(azi,360/knaz(9))
425 <        );
426 < kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
427 < ';
428 < my $ndiv = 145;
429 < # Compute scattering data using rtcontrib
430 < my @tfarr;
431 < my @rfarr;
432 < my @tbarr;
433 < my @rbarr;
434 < my $cmd;
435 < my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
436 <        "-e '$kcal' -b kbin -bn $ndiv " .
437 <        "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
438 < my $rccmd = "rcalc -e '$tcal' " .
439 <        "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
440 <        q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
441 <        q[-o '${  oval  },'];
442 < if ( $doforw ) {
443 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
444 <        "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
445 <        "-e 'yp=(\$2+rand(.37*recno-44))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
446 <        "-e 'zp:$dim[4]' " .
447 <        q{-e 'Kbin=$1;x1=rand(2.75*recno+3.1);x2=rand(-2.01*recno-3.37)' } .
448 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp-Dz;$4=Dx;$5=Dy;$6=Dz' } .
449 <        "| $rtcmd";
450 < system "$cmd" || die "Failure running: $cmd\n";
451 < @tfarr = `$rccmd $td/$fmodnm.flt`;
452 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
453 < @rfarr = `$rccmd $td/$bmodnm.flt`;
454 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
455 < }
456 < if ( $doback ) {
457 < $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
458 <        "-e 'xp=(\$3+rand(.35*recno-15))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
459 <        "-e 'yp=(\$2+rand(.86*recno+11))*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
460 <        "-e 'zp:$dim[5]' " .
461 <        q{-e 'Kbin=$1;x1=rand(1.21*recno+2.75);x2=rand(-3.55*recno-7.57)' } .
462 <        q{-e '$1=xp-Dx;$2=yp-Dy;$3=zp+Dz;$4=Dx;$5=Dy;$6=-Dz' } .
463 <        "| $rtcmd";
464 < system "$cmd" || die "Failure running: $cmd\n";
465 < @tbarr = `$rccmd $td/$bmodnm.flt`;
466 < die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
467 < @rbarr = `$rccmd $td/$fmodnm.flt`;
468 < die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
469 < }
470 < # Output angle basis
471 < print
472 < '       <DataDefinition>
473 <                <IncidentDataStructure>Columns</IncidentDataStructure>
474 <                <AngleBasis>
475 <                        <AngleBasisName>LBNL/Klems Full</AngleBasisName>
476 <                        <AngleBasisBlock>
477 <                                <Theta>0</Theta>
478 <                                <nPhis>1</nPhis>
479 <                                <ThetaBounds>
480 <                                        <LowerTheta>0</LowerTheta>
481 <                                        <UpperTheta>5</UpperTheta>
482 <                                </ThetaBounds>
483 <                                </AngleBasisBlock>
484 <                                <AngleBasisBlock>
485 <                                <Theta>10</Theta>
486 <                                <nPhis>8</nPhis>
487 <                                <ThetaBounds>
488 <                                        <LowerTheta>5</LowerTheta>
489 <                                        <UpperTheta>15</UpperTheta>
490 <                                </ThetaBounds>
491 <                                </AngleBasisBlock>
492 <                                <AngleBasisBlock>
493 <                                <Theta>20</Theta>
494 <                                <nPhis>16</nPhis>
495 <                                <ThetaBounds>
496 <                                        <LowerTheta>15</LowerTheta>
497 <                                        <UpperTheta>25</UpperTheta>
498 <                                </ThetaBounds>
499 <                                </AngleBasisBlock>
500 <                                <AngleBasisBlock>
501 <                                <Theta>30</Theta>
502 <                                <nPhis>20</nPhis>
503 <                                <ThetaBounds>
504 <                                        <LowerTheta>25</LowerTheta>
505 <                                        <UpperTheta>35</UpperTheta>
506 <                                </ThetaBounds>
507 <                                </AngleBasisBlock>
508 <                                <AngleBasisBlock>
509 <                                <Theta>40</Theta>
510 <                                <nPhis>24</nPhis>
511 <                                <ThetaBounds>
512 <                                        <LowerTheta>35</LowerTheta>
513 <                                        <UpperTheta>45</UpperTheta>
514 <                                </ThetaBounds>
515 <                                </AngleBasisBlock>
516 <                                <AngleBasisBlock>
517 <                                <Theta>50</Theta>
518 <                                <nPhis>24</nPhis>
519 <                                <ThetaBounds>
520 <                                        <LowerTheta>45</LowerTheta>
521 <                                        <UpperTheta>55</UpperTheta>
522 <                                </ThetaBounds>
523 <                                </AngleBasisBlock>
524 <                                <AngleBasisBlock>
525 <                                <Theta>60</Theta>
526 <                                <nPhis>24</nPhis>
527 <                                <ThetaBounds>
528 <                                        <LowerTheta>55</LowerTheta>
529 <                                        <UpperTheta>65</UpperTheta>
530 <                                </ThetaBounds>
531 <                                </AngleBasisBlock>
532 <                                <AngleBasisBlock>
533 <                                <Theta>70</Theta>
534 <                                <nPhis>16</nPhis>
535 <                                <ThetaBounds>
536 <                                        <LowerTheta>65</LowerTheta>
537 <                                        <UpperTheta>75</UpperTheta>
538 <                                </ThetaBounds>
539 <                                </AngleBasisBlock>
540 <                                <AngleBasisBlock>
541 <                                <Theta>82.5</Theta>
542 <                                <nPhis>12</nPhis>
543 <                                <ThetaBounds>
544 <                                        <LowerTheta>75</LowerTheta>
545 <                                        <UpperTheta>90</UpperTheta>
546 <                                </ThetaBounds>
547 <                        </AngleBasisBlock>
548 <                </AngleBasis>
549 <        </DataDefinition>
550 < ';
551 < if ( $doforw ) {
552 < print
553 < '       <WavelengthData>
554 <                <LayerNumber>System</LayerNumber>
555 <                <Wavelength unit="Integral">Visible</Wavelength>
556 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
557 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
558 <                <WavelengthDataBlock>
559 <                        <WavelengthDataDirection>Transmission Front</WavelengthDataDirection>
560 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
561 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
562 <                        <ScatteringDataType>BTDF</ScatteringDataType>
563 <                        <ScatteringData>
564 < ';
565 < # Output front transmission (transposed order)
566 < for (my $od = 0; $od < $ndiv; $od++) {
567 <        for (my $id = 0; $id < $ndiv; $id++) {
568 <                print $tfarr[$ndiv*$id + $od];
454 >
455 >        # Run rfluxmtx processes to compute each side
456 >        do_matrix_dir(0) if ( $doback );
457 >        do_matrix_dir(1) if ( $doforw );
458 >
459 > }       # end of sub do_matrix_bsdf()
460 >
461 > # Call rfluxmtx and process tensor tree BSDF for the given direction
462 > sub do_matrix_dir {
463 >        my $forw = shift;
464 >        my $r = do_phase();
465 >        if (!$r) { return; }
466 >        $r = ($r < 0) ? " -r" : "";
467 >        my $cmd;
468 >        my $sender = ($bsender,$fsender)[$forw];
469 >        $cmd = "$rfluxmtx$r -fd $sender $receivers -i $octree";
470 >        print STDERR "Starting: $cmd\n";
471 >        system $cmd;
472 >        die "Failure running rfluxmtx" if ( $? );
473 >        matrix_out($forw);
474 > }       # end of do_matrix_dir()
475 >
476 > sub matrix_out {
477 >        my $forw = shift;
478 >        my ($refldat,$transdat);
479 >        if ( $forw ) {
480 >                $transdat = $facedat;
481 >                $refldat = $behinddat;
482 >        } else {
483 >                $transdat = $behinddat;
484 >                $refldat = $facedat;
485          }
486 <        print "\n";
487 < }
488 < print
489 < '                       </ScatteringData>
490 <                </WavelengthDataBlock>
491 <        </WavelengthData>
576 <        <WavelengthData>
577 <                <LayerNumber>System</LayerNumber>
578 <                <Wavelength unit="Integral">Visible</Wavelength>
579 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
580 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
581 <                <WavelengthDataBlock>
582 <                        <WavelengthDataDirection>Reflection Front</WavelengthDataDirection>
583 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
584 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
585 <                        <ScatteringDataType>BRDF</ScatteringDataType>
586 <                        <ScatteringData>
587 < ';
588 < # Output front reflection (transposed order)
589 < for (my $od = 0; $od < $ndiv; $od++) {
590 <        for (my $id = 0; $id < $ndiv; $id++) {
591 <                print $rfarr[$ndiv*$id + $od];
486 >        # Output transmission
487 >        my $ttyp = ("tb","tf")[$forw];
488 >        matrix_comp($ttyp, "Visible", $transdat, ($tb,$tf)[$forw]);
489 >        if ( $docolor ) {
490 >                matrix_comp($ttyp, "CIE-X", $transdat, ($tbx,$tfx)[$forw]);
491 >                matrix_comp($ttyp, "CIE-Z", $transdat, ($tbz,$tfz)[$forw]);
492          }
493 <        print "\n";
494 < }
495 < print
496 < '                       </ScatteringData>
497 <                </WavelengthDataBlock>
498 <        </WavelengthData>
599 < ';
600 < }
601 < if ( $doback ) {
602 < print
603 < '       <WavelengthData>
604 <                <LayerNumber>System</LayerNumber>
605 <                <Wavelength unit="Integral">Visible</Wavelength>
606 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
607 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
608 <                <WavelengthDataBlock>
609 <                        <WavelengthDataDirection>Transmission Back</WavelengthDataDirection>
610 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
611 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
612 <                        <ScatteringDataType>BTDF</ScatteringDataType>
613 <                        <ScatteringData>
614 < ';
615 < # Output back transmission (transposed order)
616 < for (my $od = 0; $od < $ndiv; $od++) {
617 <        for (my $id = 0; $id < $ndiv; $id++) {
618 <                print $tbarr[$ndiv*$id + $od];
493 >        # Output reflection
494 >        my $rtyp = ("rb","rf")[$forw];
495 >        matrix_comp($rtyp, "Visible", $refldat, ($rb,$rf)[$forw]);
496 >        if ( $docolor ) {
497 >                matrix_comp($rtyp, "CIE-X", $refldat, ($rbx,$rfx)[$forw]);
498 >                matrix_comp($rtyp, "CIE-Z", $refldat, ($rbz,$rfz)[$forw]);
499          }
500 <        print "\n";
501 < }
502 < print
503 < '                       </ScatteringData>
504 <                </WavelengthDataBlock>
505 <        </WavelengthData>
506 <        <WavelengthData>
507 <                <LayerNumber>System</LayerNumber>
508 <                <Wavelength unit="Integral">Visible</Wavelength>
509 <                <SourceSpectrum>CIE Illuminant D65 1nm.ssp</SourceSpectrum>
510 <                <DetectorSpectrum>ASTM E308 1931 Y.dsp</DetectorSpectrum>
511 <                <WavelengthDataBlock>
512 <                        <WavelengthDataDirection>Reflection Back</WavelengthDataDirection>
513 <                        <ColumnAngleBasis>LBNL/Klems Full</ColumnAngleBasis>
514 <                        <RowAngleBasis>LBNL/Klems Full</RowAngleBasis>
635 <                        <ScatteringDataType>BRDF</ScatteringDataType>
636 <                        <ScatteringData>
637 < ';
638 < # Output back reflection (transposed order)
639 < for (my $od = 0; $od < $ndiv; $od++) {
640 <        for (my $id = 0; $id < $ndiv; $id++) {
641 <                print $rbarr[$ndiv*$id + $od];
500 > }       # end of matrix_out()
501 >
502 > # Transpose matrix component data and save to file
503 > sub matrix_comp {
504 >        my $typ = shift;
505 >        my $spec = shift;
506 >        my $src = shift;
507 >        my $dest = shift;
508 >        my $cmd = "rmtxop -fa -t";
509 >        if ("$spec" eq "Visible") {
510 >                $cmd .= " -c 0.2651 0.6701 0.0648";
511 >        } elsif ("$spec" eq "CIE-X") {
512 >                $cmd .= " -c 0.5141 0.3239 0.1620";
513 >        } elsif ("$spec" eq "CIE-Z") {
514 >                $cmd .= " -c 0.0241 0.1229 0.8530";
515          }
516 <        print "\n";
517 < }
518 < print
519 < '                       </ScatteringData>
520 <                </WavelengthDataBlock>
521 <        </WavelengthData>
522 < ';
523 < }
524 < }
525 < #------------- End of do_matrix_bsdf() --------------#
516 >        $cmd .= " $src | rcollate -ho -oc 145";
517 >        print STDERR "Running: $cmd\n";
518 >        system "$cmd > $dest";
519 >        die "Failure running rmtxop" if ( $? );
520 >        if ( "$spec" ne "$curspec" ) {
521 >                $wrapper .= " -s $spec";
522 >                $curspec = $spec;
523 >        }
524 >        $wrapper .= " -$typ $dest";
525 > }       # end of matrix_comp()
526 >
527 > #------------- End of do_matrix_bsdf() & subroutines --------------#

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines